Index: anches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixBitmapView.Designer.cs
===================================================================
--- /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixBitmapView.Designer.cs	(revision 12592)
+++ 	(revision )
@@ -1,57 +1,0 @@
-﻿namespace HeuristicLab.Problems.NK {
-  partial class BoolMatrixView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.pictureBox = new System.Windows.Forms.PictureBox();
-      ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).BeginInit();
-      this.SuspendLayout();
-      // 
-      // pictureBox
-      // 
-      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.pictureBox.Location = new System.Drawing.Point(3, 3);
-      this.pictureBox.Name = "pictureBox";
-      this.pictureBox.Size = new System.Drawing.Size(144, 144);
-      this.pictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
-      this.pictureBox.TabIndex = 0;
-      this.pictureBox.TabStop = false;
-      // 
-      // BoolMatrixView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.pictureBox);
-      this.Name = "BoolMatrixView";
-      ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).EndInit();
-      this.ResumeLayout(false);
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.PictureBox pictureBox;
-  }
-}
Index: anches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixBitmapView.cs
===================================================================
--- /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixBitmapView.cs	(revision 12592)
+++ 	(revision )
@@ -1,116 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.ComponentModel;
-using System.Drawing;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Problems.NK {
-
-  [View("BoolMatrixView")]
-  [Content(typeof(BoolMatrix), IsDefaultView = false)]
-  public sealed partial class BoolMatrixView : ItemView {
-    private BackgroundWorker worker;
-
-    public new BoolMatrix Content {
-      get { return (BoolMatrix)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public BoolMatrixView() {
-      InitializeComponent();
-    }
-
-    protected override void DeregisterContentEvents() {
-      Content.ToStringChanged -= Content_ToStringChanged;
-      base.DeregisterContentEvents();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ToStringChanged += Content_ToStringChanged;
-    }
-
-    #region Event Handlers (Content)
-    void Content_ToStringChanged(object sender, EventArgs e) {
-      Rebuild();
-    }
-    #endregion
-
-    private void Rebuild() {
-      int width = pictureBox.Width;
-      int height = pictureBox.Height;
-      int tileWidth = width / Content.Columns;
-      int tileHeight = height / Content.Rows;
-      int border = (int)Math.Round((tileWidth + tileHeight) / 2.0 * 0.05);
-      var bitmap = new Bitmap(width, height);
-
-      if (worker != null)
-        worker.CancelAsync();
-
-      if (tileWidth == 0 || tileHeight == 0) {
-        using (Graphics g = Graphics.FromImage(bitmap)) {
-          g.DrawString("BoolMatrix is to big to draw.", DefaultFont, new SolidBrush(Color.Black), 10.0f, height / 2.0f);
-          g.Flush();
-        }
-        pictureBox.Image = bitmap;
-        return;
-      }
-
-      worker = new BackgroundWorker();
-      worker.WorkerSupportsCancellation = true;
-      worker.DoWork += (s, a) => {
-        using (Graphics g = Graphics.FromImage(bitmap)) {
-          for (int i = 0; i < Content.Rows; i++) {
-            for (int j = 0; j < Content.Columns; j++) {
-              if (worker.CancellationPending) {
-                a.Cancel = true;
-                break;
-              }
-              g.FillRectangle(Content[i, j] ? Brushes.Black : Brushes.White, i * tileWidth, j * tileHeight,
-                                                                    tileWidth - border, tileHeight - border);
-            }
-          }
-          g.Flush();
-        }
-      };
-      worker.RunWorkerCompleted += (s, a) => {
-        if (!a.Cancelled)
-          pictureBox.Image = bitmap;
-        if (!worker.CancellationPending)
-          worker = null;
-      };
-      worker.RunWorkerAsync();
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        pictureBox.Image = new Bitmap(1, 1);
-      } else {
-        Rebuild();
-      }
-    }
-  }
-}
Index: anches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixBitmapView.resx
===================================================================
--- /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixBitmapView.resx	(revision 12592)
+++ 	(revision )
@@ -1,120 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>
Index: /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.Designer.cs
===================================================================
--- /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.Designer.cs	(revision 12593)
+++ /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.Designer.cs	(revision 12593)
@@ -0,0 +1,57 @@
+﻿namespace HeuristicLab.Problems.NK {
+  partial class BoolMatrixView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.pictureBox = new System.Windows.Forms.PictureBox();
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // pictureBox
+      // 
+      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.pictureBox.Location = new System.Drawing.Point(3, 3);
+      this.pictureBox.Name = "pictureBox";
+      this.pictureBox.Size = new System.Drawing.Size(144, 144);
+      this.pictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
+      this.pictureBox.TabIndex = 0;
+      this.pictureBox.TabStop = false;
+      // 
+      // BoolMatrixView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.pictureBox);
+      this.Name = "BoolMatrixView";
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).EndInit();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.PictureBox pictureBox;
+  }
+}
Index: /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.cs
===================================================================
--- /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.cs	(revision 12593)
+++ /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.cs	(revision 12593)
@@ -0,0 +1,116 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.ComponentModel;
+using System.Drawing;
+using HeuristicLab.Core.Views;
+using HeuristicLab.Data;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Problems.NK {
+
+  [View("BoolMatrixView")]
+  [Content(typeof(BoolMatrix), IsDefaultView = false)]
+  public sealed partial class BoolMatrixView : ItemView {
+    private BackgroundWorker worker;
+
+    public new BoolMatrix Content {
+      get { return (BoolMatrix)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public BoolMatrixView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.ToStringChanged -= Content_ToStringChanged;
+      base.DeregisterContentEvents();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ToStringChanged += Content_ToStringChanged;
+    }
+
+    #region Event Handlers (Content)
+    void Content_ToStringChanged(object sender, EventArgs e) {
+      Rebuild();
+    }
+    #endregion
+
+    private void Rebuild() {
+      int width = pictureBox.Width;
+      int height = pictureBox.Height;
+      int tileWidth = width / Content.Columns;
+      int tileHeight = height / Content.Rows;
+      int border = (int)Math.Round((tileWidth + tileHeight) / 2.0 * 0.05);
+      var bitmap = new Bitmap(width, height);
+
+      if (worker != null)
+        worker.CancelAsync();
+
+      if (tileWidth == 0 || tileHeight == 0) {
+        using (Graphics g = Graphics.FromImage(bitmap)) {
+          g.DrawString("BoolMatrix is to big to draw.", DefaultFont, new SolidBrush(Color.Black), 10.0f, height / 2.0f);
+          g.Flush();
+        }
+        pictureBox.Image = bitmap;
+        return;
+      }
+
+      worker = new BackgroundWorker();
+      worker.WorkerSupportsCancellation = true;
+      worker.DoWork += (s, a) => {
+        using (Graphics g = Graphics.FromImage(bitmap)) {
+          for (int i = 0; i < Content.Rows; i++) {
+            for (int j = 0; j < Content.Columns; j++) {
+              if (worker.CancellationPending) {
+                a.Cancel = true;
+                break;
+              }
+              g.FillRectangle(Content[i, j] ? Brushes.Black : Brushes.White, i * tileWidth, j * tileHeight,
+                                                                    tileWidth - border, tileHeight - border);
+            }
+          }
+          g.Flush();
+        }
+      };
+      worker.RunWorkerCompleted += (s, a) => {
+        if (!a.Cancelled)
+          pictureBox.Image = bitmap;
+        if (!worker.CancellationPending)
+          worker = null;
+      };
+      worker.RunWorkerAsync();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        pictureBox.Image = new Bitmap(1, 1);
+      } else {
+        Rebuild();
+      }
+    }
+  }
+}
Index: /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/HeuristicLab.Problems.NK.Views.csproj
===================================================================
--- /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/HeuristicLab.Problems.NK.Views.csproj	(revision 12592)
+++ /branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/HeuristicLab.Problems.NK.Views.csproj	(revision 12593)
@@ -138,17 +138,12 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="BoolMatrixBitmapView.cs">
+    <Compile Include="BoolMatrixView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="BoolMatrixBitmapView.Designer.cs">
-      <DependentUpon>BoolMatrixBitmapView.cs</DependentUpon>
+    <Compile Include="BoolMatrixView.Designer.cs">
+      <DependentUpon>BoolMatrixView.cs</DependentUpon>
     </Compile>
     <Compile Include="HeuristicLabProblemsNKViewsPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-  </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="BoolMatrixBitmapView.resx">
-      <DependentUpon>BoolMatrixBitmapView.cs</DependentUpon>
-    </EmbeddedResource>
   </ItemGroup>
   <ItemGroup>