Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.cs	(revision 12594)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK.Views/BoolMatrixView.cs	(revision 12596)
@@ -53,9 +53,7 @@
     }
 
-    #region Event Handlers (Content)
     void Content_ToStringChanged(object sender, EventArgs e) {
       Rebuild();
     }
-    #endregion
 
     private void Rebuild() {
@@ -72,5 +70,5 @@
       if (tileWidth == 0 || tileHeight == 0) {
         using (Graphics g = Graphics.FromImage(bitmap)) {
-          g.DrawString("BoolMatrix is to big to draw.", DefaultFont, new SolidBrush(Color.Black), 10.0f, height / 2.0f);
+          g.DrawString("BoolMatrix is too big to draw.", DefaultFont, new SolidBrush(Color.Black), 10.0f, height / 2.0f);
           g.Flush();
         }
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/NKLandscape.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/NKLandscape.cs	(revision 12594)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/NKLandscape.cs	(revision 12596)
@@ -97,6 +97,10 @@
       get { return WeightsInitializerParameter.Value; }
     }
-    public int Q { get { return QParameter.Value.Value; } }
-    public double P { get { return PParameter.Value.Value; } }
+    public int Q {
+      get { return QParameter.Value.Value; }
+    }
+    public double P {
+      get { return PParameter.Value.Value; }
+    }
     public IntValue Seed {
       get { return SeedParameter.Value; }
@@ -113,5 +117,5 @@
     private static HashAlgorithm hashAlgorithmP;
 
-    public static HashAlgorithm HashAlgorithm {
+    private static HashAlgorithm HashAlgorithm {
       get {
         if (hashAlgorithm == null) {
@@ -122,5 +126,5 @@
     }
 
-    public static HashAlgorithm HashAlgorithmP {
+    private static HashAlgorithm HashAlgorithmP {
       get {
         if (hashAlgorithmP == null) {
@@ -142,5 +146,5 @@
       random = new MersenneTwister();
 
-      Parameters.Add(new ValueParameter<BoolMatrix>("GeneInteractions", "Every column gives the participating genes for each fitness component"));
+      Parameters.Add(new ValueParameter<BoolMatrix>("GeneInteractions", "Every column gives the participating genes for each fitness component."));
       Parameters.Add(new ValueParameter<IntValue>("ProblemSeed", "The seed used for the random number generator.", new IntValue(0)));
       random.Reset(Seed.Value);
@@ -149,9 +153,9 @@
       Parameters.Add(new ValueParameter<IntValue>("NrOfFitnessComponents", "Number of fitness component functions. (nr of columns in the interaction column)", new IntValue(10)));
       Parameters.Add(new ValueParameter<IntValue>("NrOfInteractions", "Number of genes interacting with each other. (nr of True values per column in the interaction matrix)", new IntValue(3)));
-      Parameters.Add(new ValueParameter<IntValue>("Q", "Number of allowed fitness values in the (virutal) random table, or zero", new IntValue(0)));
-      Parameters.Add(new ValueParameter<DoubleValue>("P", "Probability of any entry in the (virtual) random table being zero", new DoubleValue(0)));
+      Parameters.Add(new ValueParameter<IntValue>("Q", "Number of allowed fitness values in the (virutal) random table, or zero.", new IntValue(0)));
+      Parameters.Add(new ValueParameter<DoubleValue>("P", "Probability of any entry in the (virtual) random table being zero.", new DoubleValue(0)));
       Parameters.Add(new ValueParameter<DoubleArray>("Weights", "The weights for the component functions. If shorted, will be repeated.", new DoubleArray(new[] { 1.0 })));
-      Parameters.Add(new OptionalConstrainedValueParameter<IInteractionInitializer>("InteractionInitializer", "Initialize interactions within the component functions."));
-      Parameters.Add(new OptionalConstrainedValueParameter<IWeightsInitializer>("WeightsInitializer", "Operator to initialize weights distribution"));
+      Parameters.Add(new ConstrainedValueParameter<IInteractionInitializer>("InteractionInitializer", "Initialize interactions within the component functions."));
+      Parameters.Add(new ConstrainedValueParameter<IWeightsInitializer>("WeightsInitializer", "Operator to initialize the weights distribution."));
 
       //allow just the standard NK[P,Q] formulations at the moment