Index: branches/BubbleChart/HeuristicLab.Optimization.BubbleChart/3.3/BubbleChartView.Designer.cs
===================================================================
--- branches/BubbleChart/HeuristicLab.Optimization.BubbleChart/3.3/BubbleChartView.Designer.cs	(revision 12498)
+++ branches/BubbleChart/HeuristicLab.Optimization.BubbleChart/3.3/BubbleChartView.Designer.cs	(revision 12600)
@@ -61,4 +61,5 @@
       this.levelNumericUpDown = new System.Windows.Forms.NumericUpDown();
       this.includeChildrenCheckBox = new System.Windows.Forms.CheckBox();
+      this.sizeTrackBar = new System.Windows.Forms.TrackBar();
       ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
       this.childrenGroupBox.SuspendLayout();
@@ -68,4 +69,5 @@
       this.splitContainer.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.levelNumericUpDown)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.sizeTrackBar)).BeginInit();
       this.SuspendLayout();
       // 
@@ -73,5 +75,5 @@
       // 
       this.yLabel.AutoSize = true;
-      this.yLabel.Location = new System.Drawing.Point(305, 6);
+      this.yLabel.Location = new System.Drawing.Point(218, 6);
       this.yLabel.Name = "yLabel";
       this.yLabel.Size = new System.Drawing.Size(15, 13);
@@ -105,5 +107,5 @@
       series1.YValuesPerPoint = 2;
       this.chart.Series.Add(series1);
-      this.chart.Size = new System.Drawing.Size(880, 668);
+      this.chart.Size = new System.Drawing.Size(965, 668);
       this.chart.TabIndex = 7;
       this.chart.AxisViewChanged += new System.EventHandler<System.Windows.Forms.DataVisualization.Charting.ViewEventArgs>(this.chart_AxisViewChanged);
@@ -113,5 +115,5 @@
       this.yAxisComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.yAxisComboBox.FormattingEnabled = true;
-      this.yAxisComboBox.Location = new System.Drawing.Point(326, 3);
+      this.yAxisComboBox.Location = new System.Drawing.Point(239, 2);
       this.yAxisComboBox.Name = "yAxisComboBox";
       this.yAxisComboBox.Size = new System.Drawing.Size(340, 21);
@@ -138,5 +140,5 @@
       this.treeView.Location = new System.Drawing.Point(6, 19);
       this.treeView.Name = "treeView";
-      this.treeView.Size = new System.Drawing.Size(175, 643);
+      this.treeView.Size = new System.Drawing.Size(90, 643);
       this.treeView.TabIndex = 10;
       this.treeView.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.treeView_AfterCheck);
@@ -151,5 +153,5 @@
       this.childrenGroupBox.Location = new System.Drawing.Point(3, 3);
       this.childrenGroupBox.Name = "childrenGroupBox";
-      this.childrenGroupBox.Size = new System.Drawing.Size(187, 668);
+      this.childrenGroupBox.Size = new System.Drawing.Size(102, 668);
       this.childrenGroupBox.TabIndex = 11;
       this.childrenGroupBox.TabStop = false;
@@ -172,5 +174,5 @@
       this.splitContainer.Panel2.Controls.Add(this.chart);
       this.splitContainer.Size = new System.Drawing.Size(1083, 674);
-      this.splitContainer.SplitterDistance = 193;
+      this.splitContainer.SplitterDistance = 108;
       this.splitContainer.TabIndex = 12;
       // 
@@ -180,5 +182,5 @@
       this.sizeComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.sizeComboBox.FormattingEnabled = true;
-      this.sizeComboBox.Location = new System.Drawing.Point(806, 3);
+      this.sizeComboBox.Location = new System.Drawing.Point(728, 2);
       this.sizeComboBox.Name = "sizeComboBox";
       this.sizeComboBox.Size = new System.Drawing.Size(280, 21);
@@ -190,5 +192,5 @@
       this.sizeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.sizeLabel.AutoSize = true;
-      this.sizeLabel.Location = new System.Drawing.Point(734, 6);
+      this.sizeLabel.Location = new System.Drawing.Point(656, 5);
       this.sizeLabel.Name = "sizeLabel";
       this.sizeLabel.Size = new System.Drawing.Size(66, 13);
@@ -227,4 +229,17 @@
       this.includeChildrenCheckBox.CheckedChanged += new System.EventHandler(this.includeChildrenCheckBox_CheckedChanged);
       // 
+      // sizeTrackBar
+      // 
+      this.sizeTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.sizeTrackBar.Location = new System.Drawing.Point(1019, 3);
+      this.sizeTrackBar.Maximum = 20;
+      this.sizeTrackBar.Minimum = -20;
+      this.sizeTrackBar.Name = "sizeTrackBar";
+      this.sizeTrackBar.Size = new System.Drawing.Size(64, 45);
+      this.sizeTrackBar.TabIndex = 18;
+      this.sizeTrackBar.TickFrequency = 20;
+      this.sizeTrackBar.TickStyle = System.Windows.Forms.TickStyle.TopLeft;
+      this.sizeTrackBar.ValueChanged += new System.EventHandler(this.sizeTrackBar_ValueChanged);
+      // 
       // BubbleChartView
       // 
@@ -233,4 +248,5 @@
       this.BackColor = System.Drawing.SystemColors.Window;
       this.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
+      this.Controls.Add(this.sizeTrackBar);
       this.Controls.Add(this.includeChildrenCheckBox);
       this.Controls.Add(this.levelNumericUpDown);
@@ -252,4 +268,5 @@
       this.splitContainer.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.levelNumericUpDown)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.sizeTrackBar)).EndInit();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -272,4 +289,5 @@
     private System.Windows.Forms.NumericUpDown levelNumericUpDown;
     private System.Windows.Forms.CheckBox includeChildrenCheckBox;
+    private System.Windows.Forms.TrackBar sizeTrackBar;
   }
 }