Index: /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 12615)
+++ /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 12616)
@@ -166,4 +166,5 @@
     <Compile Include="Interfaces\IFixedValueParameter.cs" />
     <Compile Include="Interfaces\IOperatorGraphOperator.cs" />
+    <Compile Include="Interfaces\IProgrammableItem.cs" />
     <Compile Include="Interfaces\IStatefulItem.cs" />
     <Compile Include="OperatorExecutionException.cs" />
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IProgrammableItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IProgrammableItem.cs	(revision 12616)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IProgrammableItem.cs	(revision 12616)
@@ -0,0 +1,24 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core {
+  public interface IProgrammableItem { }
+}
Index: /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 12615)
+++ /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 12616)
@@ -42,5 +42,5 @@
   [Item("ProgrammableOperator", "An operator that can be programmed for arbitrary needs.")]
   [StorableClass]
-  public class ProgrammableOperator : Operator, IParameterizedNamedItem, IStorableContent {
+  public class ProgrammableOperator : Operator, IParameterizedNamedItem, IStorableContent, IProgrammableItem {
 
     #region Fields & Properties
@@ -280,6 +280,5 @@
             assemblies.Add(a, false);
           }
-        }
-        catch (NotSupportedException) {
+        } catch (NotSupportedException) {
           // NotSupportedException is thrown while accessing 
           // the Location property of the anonymously hosted
Index: /trunk/sources/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProgrammableProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProgrammableProblem.cs	(revision 12615)
+++ /trunk/sources/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProgrammableProblem.cs	(revision 12616)
@@ -33,5 +33,5 @@
   [Creatable(CreatableAttribute.Categories.Problems, Priority = 120)]
   [StorableClass]
-  public sealed class MultiObjectiveProgrammableProblem : MultiObjectiveBasicProblem<IEncoding> {
+  public sealed class MultiObjectiveProgrammableProblem : MultiObjectiveBasicProblem<IEncoding>, IProgrammableItem {
     public static new Image StaticItemImage {
       get { return VSImageLibrary.Script; }
Index: /trunk/sources/HeuristicLab.Problems.Programmable/3.3/SingleObjectiveProgrammableProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Programmable/3.3/SingleObjectiveProgrammableProblem.cs	(revision 12615)
+++ /trunk/sources/HeuristicLab.Problems.Programmable/3.3/SingleObjectiveProgrammableProblem.cs	(revision 12616)
@@ -35,5 +35,5 @@
   [Creatable(CreatableAttribute.Categories.Problems, Priority = 100)]
   [StorableClass]
-  public sealed class SingleObjectiveProgrammableProblem : SingleObjectiveBasicProblem<IEncoding> {
+  public sealed class SingleObjectiveProgrammableProblem : SingleObjectiveBasicProblem<IEncoding>, IProgrammableItem {
     public static new Image StaticItemImage {
       get { return VSImageLibrary.Script; }
Index: /trunk/sources/HeuristicLab.Scripting/3.3/Script.cs
===================================================================
--- /trunk/sources/HeuristicLab.Scripting/3.3/Script.cs	(revision 12615)
+++ /trunk/sources/HeuristicLab.Scripting/3.3/Script.cs	(revision 12616)
@@ -37,5 +37,5 @@
 namespace HeuristicLab.Scripting {
   [StorableClass]
-  public class Script : NamedItem {
+  public class Script : NamedItem, IProgrammableItem {
     protected virtual string CodeTemplate {
       get { return string.Empty; }