Index: branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/BoolMatrixView.Designer.cs
===================================================================
--- branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/BoolMatrixView.Designer.cs	(revision 12633)
+++ branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/BoolMatrixView.Designer.cs	(revision 12633)
@@ -0,0 +1,57 @@
+﻿namespace HeuristicLab.Data.Views {
+  partial class BoolMatrixView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.pictureBox = new System.Windows.Forms.PictureBox();
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // pictureBox
+      // 
+      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.pictureBox.Location = new System.Drawing.Point(3, 3);
+      this.pictureBox.Name = "pictureBox";
+      this.pictureBox.Size = new System.Drawing.Size(144, 144);
+      this.pictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
+      this.pictureBox.TabIndex = 0;
+      this.pictureBox.TabStop = false;
+      // 
+      // BoolMatrixView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.pictureBox);
+      this.Name = "BoolMatrixView";
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).EndInit();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.PictureBox pictureBox;
+  }
+}
Index: branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/BoolMatrixView.cs
===================================================================
--- branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/BoolMatrixView.cs	(revision 12633)
+++ branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/BoolMatrixView.cs	(revision 12633)
@@ -0,0 +1,113 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.ComponentModel;
+using System.Drawing;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Data.Views {
+
+  [View("BoolMatrixView")]
+  [Content(typeof(BoolMatrix), IsDefaultView = false)]
+  public sealed partial class BoolMatrixView : ItemView {
+    private BackgroundWorker worker;
+
+    public new BoolMatrix Content {
+      get { return (BoolMatrix)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public BoolMatrixView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.ToStringChanged -= Content_ToStringChanged;
+      base.DeregisterContentEvents();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ToStringChanged += Content_ToStringChanged;
+    }
+
+    private void Content_ToStringChanged(object sender, EventArgs e) {
+      Rebuild();
+    }
+
+    private void Rebuild() {
+      int width = pictureBox.Width;
+      int height = pictureBox.Height;
+      int tileWidth = width / Content.Columns;
+      int tileHeight = height / Content.Rows;
+      int border = (int)Math.Round((tileWidth + tileHeight) / 2.0 * 0.05);
+      var bitmap = new Bitmap(width, height);
+
+      if (worker != null)
+        worker.CancelAsync();
+
+      if (tileWidth == 0 || tileHeight == 0) {
+        using (Graphics g = Graphics.FromImage(bitmap)) {
+          g.DrawString("BoolMatrix is too big to draw.", DefaultFont, new SolidBrush(Color.Black), 10.0f, height / 2.0f);
+          g.Flush();
+        }
+        pictureBox.Image = bitmap;
+        return;
+      }
+
+      worker = new BackgroundWorker();
+      worker.WorkerSupportsCancellation = true;
+      worker.DoWork += (s, a) => {
+        using (Graphics g = Graphics.FromImage(bitmap)) {
+          for (int i = 0; i < Content.Rows; i++) {
+            for (int j = 0; j < Content.Columns; j++) {
+              if (worker.CancellationPending) {
+                a.Cancel = true;
+                break;
+              }
+              g.FillRectangle(Content[i, j] ? Brushes.Black : Brushes.White, i * tileWidth, j * tileHeight,
+                                                                    tileWidth - border, tileHeight - border);
+            }
+          }
+          g.Flush();
+        }
+      };
+      worker.RunWorkerCompleted += (s, a) => {
+        if (!a.Cancelled)
+          pictureBox.Image = bitmap;
+        if (!worker.CancellationPending)
+          worker = null;
+      };
+      worker.RunWorkerAsync();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        pictureBox.Image = new Bitmap(1, 1);
+      } else {
+        Rebuild();
+      }
+    }
+  }
+}
Index: branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj
===================================================================
--- branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 12500)
+++ branches/DataPreprocessingImprovements/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 12633)
@@ -220,4 +220,10 @@
     <Compile Include="BoolValueView.Designer.cs">
       <DependentUpon>BoolValueView.cs</DependentUpon>
+    </Compile>
+	 <Compile Include="BoolMatrixView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="BoolMatrixView.Designer.cs">
+      <DependentUpon>BoolMatrixView.cs</DependentUpon>
     </Compile>
     <Compile Include="StringConvertibleMatrixVisibilityDialog.cs">